#define MAXALLEXTREMES	16384
#define MAXFUNCEXTREMES	128

class FuncNames;
class PidFunc;

class Extremes
{
    public:

	void	Init( int aorder, int andesired );
	bool	Find( double diffts, double difftss[],
		    PidFunc *ppidfuncs[], int *ippidfunc );
	void	Insert( PidFunc *ppidfunc, double diffts,
		    double difftss[], PidFunc *ppidfuncs[] );
	void	Remove( PidFunc *ppidfunc, double diffts,
		    double difftss[], PidFunc *ppidfuncs[] );
	void	Print( string name, FuncNames *pfuncnames,
		    PidFunc *ppidfuncs[] );

    private:

	int order;
	int ndesired;

	int nextremes;
	double threshold;
};

class AllExtremes : public Extremes
{
    public:

	void	Insert( PidFunc *ppidfunc, double diffts );
	void	Remove( PidFunc *ppidfunc, double diffts );
	void	Print( string name, FuncNames *pfuncnames );

    private:

	double difftss[MAXALLEXTREMES];
	PidFunc *ppidfuncs[MAXALLEXTREMES];
};

class FuncExtremes : public Extremes
{
    public:

	void	Insert( PidFunc *ppidfunc, double diffts );
	void	Remove( PidFunc *ppidfunc, double diffts );
	void	Print( string name );

    private:

	double difftss[MAXFUNCEXTREMES];
	PidFunc *ppidfuncs[MAXFUNCEXTREMES];
};
