#include <time.h>

#ifndef NONAMESPACE

#include <iostream>
#include <fstream>
using namespace std;

#else

#include <iostream.h>
#include <fstream.h>

#endif

#include <string>

#include "extremes.h"
#include "funcnames.h"
#include "pidhash.h"
#include "log.h"
#include "args.h"
#include "usage.h"
#include "outputtype.h"

int main( int argc, char **argv );
int main( int argc, char **argv )
{
	bool usage;
	int outputtype;
	string filename;
	time_t begints;
	time_t endts;

	int rc;

	Log log;

	if( rc = ParseArgs( argc, argv,
	    &usage, &outputtype, &begints, &endts, &filename ) )
	    return rc;

	if( usage )
	{
	    PrintUsage();
	}
	else
	{
	    if( rc = PrintArgs( outputtype, begints, endts, filename ) )
	        return rc;

	    if( rc = log.SetFilename( filename ) )
	        return rc;

	    if( !( rc = log.Open() ) )
	    {
	        if( outputtype == OUTPUT_DETAIL )
	            cout << "\n";

	        if( rc = log.Process( outputtype, begints, endts ) )
	            return rc;

	        if( rc = log.Close() )
	            return rc;
	    }
	    else
	    {
	        cout << "Couldn't open p4d server log!\n";
	        cout << "Perhaps p4loga --help for more information?\n";
	        return rc;
	    }
	}

	return 0;
}
