class AllExtremes;
class FuncNames;
class FuncStats;
class LinkedTS;

class PidFunc
{
    public:

		~PidFunc();

	time_t	GetStartTS();
	int	GetPid();
	string	GetUser();
	string	GetClient();
	string	GetHost();
	PidFunc	*GetNextPidFunc();

	void	SetNextPidFunc( PidFunc *anextpidfunc );

	int	Init( time_t ats, int apid,
		    string line, int iscan, int ispan, FuncNames *pfuncnames );
	void	IncrementRefCount();
	int	DecrementRefCount();
	void	Compute( time_t ts,
		    AllExtremes *maxgcomputes, AllExtremes *mingcomputes );
	void	Finish( time_t ts,
		    AllExtremes *maxgelapseds, AllExtremes *mingelapseds );
	void	PrintDetail( FuncNames *pfuncnames );
	void	PrintCSV( FuncNames *pfuncnames );
	void	PrintPretty( string prefix, FuncNames *pfuncnames );

    private:

	time_t startts;

	bool seencompute;
	LinkedTS *pfirstcomputets;
	LinkedTS *plastcomputets;
	double compute;

	string StripComma(string s);

	bool seenfinish;
	time_t finishts;
	double elapsed;

	int pid;
	string user;
	string client;
	string program;
	string host;
	FuncStats *funcstats;
	string args;

	int refcount;

	PidFunc *nextpidfunc;
};
